import React, { useCallback, useState } from 'react'
import { Form, Input, InputNumber, Modal, Upload } from 'antd'
import FormItem from '@/components/Formitem'
import { FormConfig } from '@/components/Formitem/type'
import { useModel } from 'umi'
import { RcFile } from 'antd/lib/upload'


/**新建非图文素材 */
let ImgModal = React.memo((props: { isAll?: boolean }) => {

    /*****========STA=========*****/
    const { isAll } = props
    const [queryForm, setQueryForm] = useState<{ title: string, sort: number, file: any }>({ title: '', sort: 0, file: null })
    const [fileList, setFileList] = useState<any>([])
    const [fromsubmit, setFromsubmit] = useState<() => Promise<any>>()//存放from提交事件
    const callback = useCallback((fnc: () => Promise<any>) => { setFromsubmit(fnc) }, [])//回调获取from提交事件
    const { state, typeEnum, fileOk, offEditFile } = useModel(isAll ? 'useLaunchAdq.useBdMedia' : 'useLaunchAdq.useBdMediaPup')
    const { imgVisrible, mediaType, actionItem } = state
    /*****========END=========*****/

    const onFinish = (values: any) => {
        console.log('Success:', values);
    };

    const onFinishFailed = (errorInfo: any) => {
        console.log('Failed:', errorInfo);
    };

    return <Modal
        title={(actionItem ? '编辑' : '新建') + typeEnum[mediaType as string]}
        visible={imgVisrible}
        onOk={(e) => { fileOk(e, fromsubmit); }}
        onCancel={() => {
            offEditFile();
        }}
        width={450}
        destroyOnClose
        maskClosable={false}
    >
        {/* <FormItem
            formConfig={config(typeEnum[mediaType as string])}
            flow='column'
            getFormSubmit={callback}
            defaultProps={{ sort: 0 }}
            isAll={isAll}
        /> */}
        <Form
            name="basic"
            labelCol={{ span: 4 }}
            wrapperCol={{ span: 20 }}
            autoComplete="off"
        >
            <Form.Item
                label="图片名称"
            >
                <Input value={queryForm.title} onChange={(e) => setQueryForm({ ...queryForm, title: e.target.value })} placeholder="请输入图片名称" />
            </Form.Item>
            <Form.Item
                label="排序"
                tooltip="数值越大越靠前"
            >
                <InputNumber value={queryForm.sort} onChange={(e) => setQueryForm({ ...queryForm, sort: e })} placeholder="请输入排序" />
            </Form.Item>
            <Form.Item
                label={'上传' + typeEnum[mediaType as string]}
            >
                {/* {
                    fileList?.length < 1 && <Upload
                        listType="picture-card"
                        accept='image/gif,image/jpeg,image/png,image/jpg'
                        beforeUpload={function (file: RcFile) {
                            fileChanage(file)
                            return false
                        }}
                        fileList={fileList}
                        onChange={(newFileList: any) => {
                            setFileList([...newFileList.fileList])
                        }}
                        onPreview={(file: any) => {
                            // setPreviewVisible(true)
                            setFileUrl(file.thumbUrl)
                        }}
                    >
                        {fileList?.length < 1 && '普通上传'}
                    </Upload>
                } */}
            </Form.Item>
        </Form>
    </Modal>
})
export default ImgModal
let config: (name: string,) => FormConfig[] = (name) => {
    let videoArr: FormConfig[] = [
        {
            label: name + '名称',
            tag: 'input',
            name: 'videoTitle',
            width: 200,
        },

        {
            label: name + '描述',
            tag: 'TextArea',
            name: 'videoDescription',
            width: 300,
        },
        {
            label: '排序',
            tag: 'inputNumber',
            name: 'sort',
            width: 200,
        },
        {
            label: '上传' + name,
            tag: 'inputFile',
            name: 'file',
            required: true,
            message: '请上传文件'
        }
    ]
    let imgArr: FormConfig[] = [
        {
            label: name + '名称',
            tag: 'input',
            name: 'fileName',
            width: 200,
        },
        {
            label: '排序',
            tag: 'inputNumber',
            name: 'sort',
            width: 200,
        },
        {
            label: '上传' + name,
            tag: 'imgCrop',
            name: 'file',
            required: true,
            message: '请上传文件'
        }
    ]
    let arr: FormConfig[] = [
        {
            label: name + '名称',
            tag: 'input',
            name: 'fileName',
            width: 200,
        },
        {
            label: '排序',
            tag: 'inputNumber',
            name: 'sort',
            width: 200,
        },
        {
            label: '上传' + name,
            tag: 'inputFile',
            name: 'file',
            required: true,
            message: '请上传文件'
        }
    ]
    if (name === '编辑') {
        return [
            {
                label: name + '名称',
                tag: 'input',
                name: 'fileName',
                width: 200
            },
        ]
    }
    return name === '视频' ? videoArr : name === '图片' ? imgArr : arr
}

